VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cipher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Public Enum encMethod
    Blowfish = 0
    Cast5 = 1
    DES = 2
    DES3 = 3
    DESE = 4
    IDEA = 5
'    Rijindael128 = 6
'    Rijindael192 = 7
'    Rijindael256 = 8
'    Serpent128 = 9
'    Serpent192 = 10
'    Serpent256 = 11
'    TwoFish = 12
End Enum

Public Function Encrypt(ByVal str As String, ByVal pass As String, Optional ByVal method As encMethod = Blowfish, Optional ByVal saltkey As String = "") As String
    Dim cipher As ebCryptLib.eb_c_Cipher
    Dim cvascii As New ebCryptLib.eb_c_Library
    Dim encodedDataVar As Variant
    Set cipher = New ebCryptLib.eb_c_Cipher
    Set cvascii = New ebCryptLib.eb_c_Library
    Select Case method
        Case 0 ' 18
            encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_BLOWFISH_OFB, pass, saltkey, str)
        Case 1 ' 34
            encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_CAST5_OFB, pass, saltkey, str)
        Case 2 ' 51
            encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_DES_OFB, pass, saltkey, str)
        Case 3 ' 55
            encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_DES3_OFB, pass, saltkey, str)
        Case 4 ' 59
            encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_DESE_OFB, pass, saltkey, str)
        Case 5 ' 3
            encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_IDEA_OFB, pass, saltkey, str)
'        Case 6
            'encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_RIJNDAEL_CBC_128, pass, "", str)
'        Case 7
            'encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_RIJNDAEL_ECB_192, pass, "", str)
'        Case 8
            'encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_RIJNDAEL_ECB_256, pass, "", str)
'        Case 9
            'encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_SERPENT_ECB_128, pass, "", str)
'        Case 10
            'encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_SERPENT_ECB_192, pass, "", str)
'        Case 11
            'encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_SERPENT_ECB_256, pass, "", str)
'        Case 12
            'encodedDataVar = cipher.EncryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_TWOFISH_ECB, pass, "", str)
    End Select
    Encrypt = cvascii.BLOBToHex(encodedDataVar)
End Function

Public Function Decrypt(ByVal str As String, ByVal pass As String, Optional ByVal method As encMethod = Blowfish, Optional ByVal saltkey As String = "") As String
    Dim cipher As ebCryptLib.eb_c_Cipher
    Dim cvascii As ebCryptLib.eb_c_Library
    Dim encodedDataVar As Variant
    Set cipher = New ebCryptLib.eb_c_Cipher
    Set cvascii = New ebCryptLib.eb_c_Library
    Dim c As ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM
    encodedDataVar = cvascii.HexToBLOB(str)
    Select Case method
        Case 0 ' 18
            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_BLOWFISH_OFB, pass, saltkey, encodedDataVar)
        Case 1 ' 34
            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_CAST5_OFB, pass, saltkey, encodedDataVar)
        Case 2 ' 51
            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_DES_OFB, pass, saltkey, encodedDataVar)
        Case 3 ' 55
            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_DES3_OFB, pass, saltkey, encodedDataVar)
        Case 4 ' 59
            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_DESE_OFB, pass, saltkey, encodedDataVar)
        Case 5 ' 3
            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_IDEA_OFB, pass, saltkey, encodedDataVar)
'        Case 6
'            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_RIJNDAEL_ECB_128, pass, "", encodedDataVar)
'        Case 7
'            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_RIJNDAEL_ECB_192, pass, "", encodedDataVar)
'        Case 8
'            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_RIJNDAEL_ECB_256, pass, "", encodedDataVar)
'        Case 9
'            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_SERPENT_ECB_128, pass, "", encodedDataVar)
'        Case 10
'            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_SERPENT_ECB_192, pass, "", encodedDataVar)
'        Case 11
'            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_SERPENT_ECB_256, pass, "", encodedDataVar)
'        Case 12
'            Decrypt = cipher.DecryptString(ebCryptLib.EB_CRYPT_CIPHER_ALGORITHM_TWOFISH_ECB, pass, "", encodedDataVar)
    End Select
End Function
